Index: trunk/src/emx/include/stddef.h
===================================================================
--- trunk/src/emx/include/stddef.h	(revision 1055)
+++ trunk/src/emx/include/stddef.h	(revision 1056)
@@ -1,48 +1,89 @@
-/* stddef.h (emx+gcc) */
+/*-
+ * Copyright (c) 1990, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)stddef.h	8.1 (Berkeley) 6/2/93
+ *
+ * $FreeBSD: src/include/stddef.h,v 1.9 2002/09/01 17:57:20 mike Exp $
+ */
 
-#ifndef _STDDEF_H
-#define _STDDEF_H
+/** @file
+ * FreeBSD 5.1
+ * @changed bird: EMXifications.
+ */
 
-#if defined (__cplusplus)
-extern "C" {
-#endif
+#ifndef _STDDEF_H_
+#define _STDDEF_H_
 
-#if !defined (_PTRDIFF_T)
-#define _PTRDIFF_T
-typedef long ptrdiff_t;
-#endif
+#include <sys/cdefs.h>
+#include <sys/_types.h>
 
-#if !defined (_SIZE_T)
-#define _SIZE_T
-typedef unsigned long size_t;
-#endif
+typedef	__ptrdiff_t	ptrdiff_t;
 
-#if !defined (_WCHAR_T) && !defined (__cplusplus)
-#define _WCHAR_T
-typedef unsigned short wchar_t;
-#endif
-
-#if !defined (NULL)
-#if defined (__cplusplus)
-#define NULL 0
-#else
-#define NULL ((void *)0)
+#if __BSD_VISIBLE
+#ifndef _RUNE_T_DECLARED
+typedef	__rune_t	rune_t;
+#define	_RUNE_T_DECLARED
 #endif
 #endif
 
-#define	offsetof(type, member)  ((size_t)&((type *)0)->member)
+#if !defined(_SIZE_T_DECLARED) && !defined(_SIZE_T) /* bird: emx */
+typedef	__size_t	size_t;
+#define	_SIZE_T_DECLARED
+#define	_SIZE_T                         /* bird: emx */
+#endif
+
+#ifndef	__cplusplus
+#if !define(_WCHAR_T_DECLARED) && !defined(_SIZE_T)
+typedef	__wchar_t	wchar_t;
+#define	_WCHAR_T_DECLARED
+#define	_WCHAR_T                        /* bird: emx */
+#endif
+#endif
+
+#ifndef	NULL
+#define	NULL	0
+#endif
+
+#define	offsetof(type, member)	__offsetof(type, member)
 
 
+/* bird: EMX - start */
+#define _PTRDIFF_T
 #if (!defined (__STRICT_ANSI__) && !defined (_POSIX_SOURCE)) \
     || defined (_WITH_UNDERSCORE)
-
 unsigned *__threadid (void);
 #define _threadid (__threadid ())
 
 #endif
+/* bird: EMX - end */
 
-#if defined (__cplusplus)
-}
-#endif
-
-#endif /* not _STDDEF_H */
+#endif /* _STDDEF_H_ */
Index: trunk/src/emx/include/sys/stddef.h
===================================================================
--- trunk/src/emx/include/sys/stddef.h	(revision 1056)
+++ trunk/src/emx/include/sys/stddef.h	(revision 1056)
@@ -0,0 +1,47 @@
+/*-
+ * Copyright (c) 2002 Maxime Henrion <mux@FreeBSD.org>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/sys/sys/stddef.h,v 1.1 2002/11/13 15:14:57 mux Exp $
+ */
+
+/** @file
+ * FreeBSD 5.1
+ */
+
+#ifndef _SYS_STDDEF_H_
+#define _SYS_STDDEF_H_
+
+#include <sys/cdefs.h>
+#include <machine/_types.h>
+
+typedef	__ptrdiff_t	ptrdiff_t;
+
+#define	offsetof(type, field)	__offsetof(type, field)
+
+#ifndef NULL
+#define	NULL	0
+#endif
+
+#endif /* !_SYS_STDDEF_H_ */